#!/usr/bin/perl -T
# $Id: config.cgi,v 1.5 2010/10/23 05:59:00 sofc Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Karin Soeren Koch           ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use ElchemeaHeader;
use Elchemea;
use ElchemeaUser;
use ElchemeaCGI qw(:DEFAULT :html :cgi);
use SemaforeFile;
use CGI qw(:standard :netscape);

if (param('ajax'))
{
    print header();
    unless (login_ok())
    {
        print "";
        exit;
    }
    my $a = param('action');
    if ($a && $a eq 'list')
    {
        my $user = param('user');
        my $session = param('session');
        my $fn = $userdir.$user.'/'.$session.'/config';
        exit unless (-e $fn);
	my $f = SemaforeFile->new($fn);
	my @lines = $f->readlines();
	print join("\n",@lines);
        exit;
    }
    print "";
    exit;
}


my $bc_admin = undef;
my $user;
if (!defined(param))
{
    print_header("Please log in to the Elchemea");
    print '<center>';
    &ElchemeaCGI::login;
    print '</center>';
    &print_end;
}
else
{
    if (login_ok())
    { 
	$user = ElchemeaUser->new(param('user'));
	print_header("Elchemea configuration");
	top_nav_bar_start();
	top_no_button();
	top_no_button();
	top_no_button();
	tab_newrow();
	js_back();
	top_js_return('#006600','white');
	param(-name=>'action',-value=>'') unless (param('action'));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
            /Use this/ and do {&load_final;};
	    /Load old/ and do {&load_form; last CASE;};
	    /Restore/ and do {&restore;};
	    /Backup/ and do {&backup;};
	    /Save config/ and do {&save;};
	    ### Default response ####
	    &main_page;
	}
	print_end();
    }
    else 
    {
	not_auth();
    }
}
    
exit;

sub load_form
{
    top_no_button();
    top_no_button();
    top_no_button();
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    my @sessions = (1..$user->session);
    my $config = join("\n",$user->{'_config'}[$user->session()]->readlines());
    print '<center>';
    print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr>';
    print '<td width="1%"></td>';
    print '<td width="29%"></td>';
    print '<td width="69%"></td>';
    print '<td width="1%"></td>';
    print '</tr>';
    print '<tr><td colspan=4 class="heading">';
    print "Select configuration to load";
    print '</td></tr>';
    print '<tr><td></td><td valign=top>';
    print start_form(-class=>'form',-name=>'program');
    print textarea(-name=>'test',-value=>$config,-class=>'textfield',-rows=>'25',-force=>'1',-wrap=>'OFF');
    print end_form();
    print '</td><td valign=top>';

    print '<table border=0 cellspacing=2 cellpadding=0 style="width:100%">';
    print '<tr height=40px>';
    print '<td width=5%></td>';
    print '<td width=30%></td>';
    print '<td width=5%></td>';
    print '<td width=55%></td>';
    print '<td width=5%></td>';
    print '</tr>';
    print start_form(-class=>'form',-name=>'select',-onsubmit=>'return confirm("Replace current configuration with selected configuration")');
    print_hidden();
    print '<tr><td></td><td class="heading">Selcet session</td><td></td><td>';
    print popup_menu(-name=>'session',-values=>[(@sessions)],-class=>'textfield',-default=>$user->session(),-force=>1,-onchange=>'load_progs(this);');
    print '</td></tr>';
    print '<tr><td height=40></td></tr>';
    print '<tr><td colspan=3></td><td>';
    print submit(-name=>'action',-value=>'Use this configuration',-class=>'s3');
    print '</td></tr>';
    print end_form();
    print '</table>';
    print '</td></tr></table>';
    print '</center>';
    my $s = $user->session;
    print <<END;

<script language="javascript">


function load_progs(element)
{
    var ses = element[element.selectedIndex].value;
    document.program.test.value = '';
    run_ajax('config.cgi','&action=list&session='+ses,set_prog);
}

function set_prog(t)
{
    document.program.test.value = t;
}

</script>


END

}

sub load_final()
{
    my $session = param('session');
    chomp $session;
    return if ($session == $user->session);  ## Self assignment, nothing to do ###
    my $fn = $userdir.$user->name.'/'.$session.'/config';
    return unless (-e $fn);
    my $f = SemaforeFile->new($fn);
    my @lines = $f->readlines();
    $user->{'_config'}[$user->session()]->writeline(@lines);
}

sub backup()
{
    my $backup = SemaforeFile->new($userdir.$user->name.'/config');
    my @lines = $user->{'_config'}[$user->session()]->readlines();
    $backup->writeline(@lines);
}

sub restore()
{
    my $backup = SemaforeFile->new($userdir.$user->name.'/config');
    my @lines = $backup->readlines;
    $user->{'_config'}[$user->session()]->writeline(@lines);
}

sub save
{
    my $config = param('config');
    return unless ($config);
    my @lines = split(/\n/,$config);
    $user->{'_config'}[$user->session()]->writeline(@lines);
}


sub main_page
{
    top_nav_bar_button('','','action','Load old configuration','s3');
    ElchemeaCGI::create_menu_field;
    print start_form(-class=>'form',-onsubmit=>"return confirm('Replace current configuration with backup');");
    print_hidden();
    print submit(-name=>'action',-value=>'Restore configuration',-class=>'s1');
    print end_form;
    ElchemeaCGI::create_menu_field;
    print start_form(-class=>'form',-onsubmit=>"return confirm('Replace backup configuration with current configuration');");
    print_hidden();
    print submit(-name=>'action',-value=>'Backup configuration',-class=>'s2');
    print end_form;
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    my $config = join("\n",$user->{'_config'}[$user->session()]->readlines());
    print '<center>';
    print h1("Elchemea configuration");
    print start_form(-name=>'changecfg');
    print_hidden();
    print '<table border=0 cellspacing=0 cellpadding=0>';
    print '<tr><td>';
    print textarea(-name=>'config',-value=>$config,-force=>1,-rows=>20,-cols=>70);
    print '</td></tr><tr><td>';
    print submit(-name=>'action',-value=>'Save configuration',-class=>'s3');
    print '</td></tr>';
    print '</table>';
    print end_form();
    print '</center>';
}
