#!/usr/bin/perl -T
# $Id: view_session.cgi,v 1.10 2014/01/10 09:29:26 sofc Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Karin Soeren Koch           ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use ElchemeaHeader;
use ElchemeaUser;
use Elchemea qw(:DEFAULT CGI_client);
use SemaforeFile;
use ElchemeaCGI qw(:DEFAULT :html :cgi);
use CGI qw(:standard :netscape);
use File::Copy;
my $session;
my $user;
my $dir;
my @list;

if (!defined(param))
{
    print_header("Please log in to the Elchemea");
    print '<center>';
    &ElchemeaCGI::login;
    print '</center>';
    &print_end;
}
else
{
    if (login_ok())
    { 
	$user = ElchemeaUser->new(param('user'));
	$session = param('session');
	if ($session && $session =~ /(\d+)/)
	{
	    $session = $1;
	}
	else
	{
	    $session = $user->session unless ($session);
	}
	$dir = $userdir.$user->name.'/'.$session.'/';
	@list = sort(Elchemea::get_dir_list($dir,'log$'));
	print_header("Elchemea data view");   
	my $prev = &find_prev($session);
	my $next = &find_next($session);	
	top_nav_bar_start();
        top_nav_bar_button('','','action','Session list','s3');
	if (param('session'))
	{
	    top_nav_bar_button('','','action','Show log','s6','session,,');
	    top_nav_bar_button('','','action','Save session to usb','s7','session,,');
	}
	else
	{
	    top_no_button();
	    top_no_button();
	}
        tab_newrow();
        js_back();
        top_js_return('#006600','white');
	my $a = param('action');
	$a = '' unless ($a && $a =~ /Show/);
	if (param('session'))
	{
	    if ($prev)
	    {
		top_nav_bar_button('','','',' < ','s3','session,'.$prev.',1','action,'.$a.',1');
	    }
	    else
	    {
		top_no_button();   
	    }
	    top_nav_bar_button('','','',' Show list ','s3','session,,');
	    if ($next)
	    {
		top_nav_bar_button('','','',' > ','s3','session,'.$next.',1','action,'.$a.',1');
	    }
	    else
	    {
		top_no_button();
	    }
	}
	else
	{
	    top_no_button();
	    top_no_button();
	    top_no_button();
	}
	top_nav_bar_button('main.cgi','','','To menu','s4');
        end_top_bar();
	param(-name=>'action',-value=>'') unless (param('action'));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    /Save session to usb/ and do {&sessionsave; &view_list; last CASE;};
	    /Save to usb/ and do {&filesave;};
	    /Show log/ and do {&show_log; last CASE;};
	    /Session list/ and do {&view_list; last CASE;};
	    ### Default response ####
	    &main_page;
	}
	print_end();
    }
    else 
    {
	not_auth();
    }
}
    
exit;

sub filesave
{
    my $dev = get_config_value('storage','device');
    my $res = CGI_client('mount');
    if ($res =~ /error/i)
    {
	print center(h3({-class=>'Alert'},$res)) 
    }
    else
    {
	my $dir = $userdir.$user->name.'/'.$session.'/';
	my $nr = param('file');
	if ($nr && $nr =~ /(\d+)/)
	{
	    $nr = $1;
	    my @l = Elchemea::get_dir_list($dir,$nr);
	    foreach my $f (@l)
	    {
		next if ($f =~ /program/);
		my $fn = CGI_client('unix2dos',$dir.$f);
		print center(h3({-class=>'Alert'},$fn)) if ($fn =~ /error/i);
		my $res = CGI_client('copy',$fn,$dev.'/'.$f);
		print center(h3($res));
		CGI_client('unlink',$fn);
	    }
	}
    }
    $res = CGI_client('umount');
    print center(h3({-class=>'Alert'},$res)) if ($res =~ /error/i);
}

sub sessionsave
{
    my $dir = $userdir.$user->name.'/'.$session.'/';
    my $res = CGI_client('zipusb',$dir);
    if ($res =~ /error/i)
    {
	print center(h3({-class=>'Alert'},$res));
    }
    elsif($res =~ /unmounted/)
    {
	print center(h3('Session saved to usb'));
    }
    else
    {
	print center(h3($res));
    }
}

sub find_prev($)
{
    my $session = shift;
    $session--;
    return $session if ($session);
    return undef;
}

sub find_next($)
{
    my $session = shift;
    $session++;
    return $session unless ($session > $user->session);
    return undef;
}


sub show_log()
{
    print '<center>';
    my $name = $user->get_session_name($session);
    print h2("Log for session $session, '$name'");
    my $content = $user->get_sessionlog($session);
    print textarea(-name=>'test',-value=>$content,-cols=>80,-rows=>30,-force=>'1',-wrap=>'OFF');
    print '</center>';
}

sub view_list
{
    print '<center>';
    print h1("Session list for ".$user->name);
    print '<table class="tabel" cellspacing=5 cellpadding=5><tr>';
    print '<td width="10%"></td>';
    print '<td width="35%"></td>';
    print '<td width="10%"></td>';
    print '<td width="15%"></td>';
    print '<td width="20%"></td>';
    print '<td width="10%"></td>';
    print '</tr>';
    for my $s (1..$user->session)
    {
	my $name = $user->get_session_name($s);
	print '<tr><td></td><td>';
	print start_form();
	print_hidden;
	print hidden(-name=>'session',-value=>$s,-force=>1);
	print submit(-class=>'s3',-name=>'test',-value=>"Session $s, ".$name);
	print end_form();
	print '</td><td>';
	print start_form();
	print_hidden;
	print hidden(-name=>'session',-value=>$s,-force=>1);
	print submit(-class=>'s3',-name=>'action',-value=>'Show log');
	print end_form();
	print '</td><td>';
	print button(-name=>$s,-value=>'Save to desktop',-onclick=>'zip_session(this)',-class=>'s4');
	print '</td><td>';
	print start_form();
	print_hidden;
	print hidden(-name=>'session',-value=>$s,-force=>1);
	print submit(-class=>'s3',-name=>'action',-value=>'Save session to usb');
	print end_form();
	print '</td></tr>';
    }
    print '</table>';
    print '</center>';

    print <<END;


<script lanuage="javascript">



function get_file(s)
{
    var res = s.split("\\n");
    if (res[0] == "OK")
    {
	var f = '/elchemea/png/'+res[1];
	load_file(f);
    }
}

function zip_session(e)
{
    var session = e.name;
    run_ajax('zip_file.cgi','&action=zip&session='+session,get_file);
}

function load_file(file)
{
    window.open(file,'Download','width=150,height=50,left=50,top=50');
}

</script>

END

}



sub main_page
{
    print '<center>';
    print h1("Session $session '".$user->get_session_name($session)."'");
    print '<table class="tabel" cellspacing=5 cellpadding=5><tr>';
    print '<td width="10%"></td>';
    print '<td width="20%"></td>';
    print '<td width="20%"></td>';
    print '<td width="20%"></td>';
    print '<td width="20%"></td>';
    print '<td width="10%"></td>';
    print '</tr>';
    foreach my $file (@list)
    {
	$file =~ /(\d+)\./;
	my $nr = $1;
	print '<tr><td></td><td>';
	print start_form(-action=>'show_file.cgi');
	print_hidden;
	my $tf;
	foreach my $tstr ('.i2b','.i2c','.i2p','.i2t')
	{
	    my $tfile = $file;
	    $tfile =~  s/\.\w+$/$tstr/;
	    $tf = $tfile if (-e $dir.$tfile);
	}
	print hidden(-name=>'session',-value=>$session,-force=>1);
	print hidden(-name=>'file',-value=>$nr,-force=>1);
	my $class = 's3';
	if ($tf)
	{
	    $class = 's4' if ($tf =~ /i2c/);
	    $class = 's5' if ($tf =~ /i2p/);
	    $class = 's6' if ($tf =~ /i2t/);
	}
	print submit(-class=>$class,-name=>'test',-value=>$tf) if ($tf);
	print end_form();
	print '</td><td>';
	print start_form(-action=>'show_file.cgi');
	print_hidden;
	print hidden(-name=>'session',-value=>$session,-force=>1);
	print hidden(-name=>'file',-value=>$nr,-force=>1);
	print submit(-class=>$class,-name=>'action',-value=>'Show data') if ($tf);
	print end_form();
	print '</td><td>';
	print start_form(-action=>'show_file.cgi');
	print_hidden;
	print hidden(-name=>'session',-value=>$session,-force=>1);
	print hidden(-name=>'file',-value=>$nr,-force=>1);
	print submit(-class=>$class,-name=>'action',-value=>'Show log '.$nr);
	print end_form();
	print '</td><td>';
	print start_form();
	print_hidden;
	print hidden(-name=>'session',-value=>$session,-force=>1);
	print hidden(-name=>'file',-value=>$nr,-force=>1);
	print submit(-class=>$class,-name=>'action',-value=>'Save to usb');
	print end_form();
	print '</td></tr>';
    }
    print '</table>';
    print '</center>';
}
